%define upname		xf86-video-nouveau
#define snapshot	20151008
%define snapshot	%nil
%define rel		9

%if 0%{snapshot}
%define release %mkrel 10.%{snapshot}.%{rel}
%else
%define release %mkrel %{rel}
%endif

Summary:	Accelerated open source driver for NVIDIA cards
Name:		x11-driver-video-nouveau
Version:	1.0.17
Release:	%{release}
Group:		System/X11
License:	MIT
URL:		https://nouveau.freedesktop.org/
# rm -rf xf86-video-nouveau && git clone git://anongit.freedesktop.org/git/nouveau/xf86-video-nouveau/ && cd xf86-video-nouveau/
# git archive --prefix=xf86-video-nouveau-$(date +%Y%m%d)/ --format=tar HEAD | xz > ../xf86-video-nouveau-$(date +%Y%m%d).tar.xz
%if 0%{snapshot}
Source0:	%{upname}-%{snapshot}.tar.xz
%else
Source0:	https://xorg.freedesktop.org/releases/individual/driver/%{upname}-%{version}.tar.bz2
%endif

# upstream fixes (see https://gitlab.freedesktop.org/xorg/driver/xf86-video-nouveau)
Patch1:		0001-nouveau-fixup-driver-for-new-X-server-ABI.patch
Patch2:		0002-remove-sarea.h-usage.patch

# from opensuse (better logs for missed acceleration)
Patch100:	N_xf86-video-nouveau_nva3-noaccel-info.patch

BuildRequires:	pkgconfig(libdrm_nouveau)
BuildRequires:	x11-proto-devel >= 1.0.0
BuildRequires:	pkgconfig(xorg-server) >= 1.19.0
BuildRequires:	x11-util-macros >= 1.0.1
BuildRequires:	GL-devel
BuildRequires:	pkgconfig(udev)
# force new gcc
BuildRequires:	gcc >= 12.0.1-0.20220227.2
BuildRequires:	binutils >= 1:2.38-4

Conflicts:	xorg-x11-server < 7.0
# No DKMS package for now; nouveau module is in main kernel.
# If needed, DKMS package may be resurrected, but work is needed to make it
# build with the new linux-2.6 tree of nouveau.
Obsoletes:	dkms-nouveau < 0.0.13-0.20090600
Requires:	kmod(nouveau.ko)
Requires: x11-server-common %(xserver-sdk-abi-requires videodrv)
# No firmware needed:
Obsoletes:	nouveau-firmware < 20091212-2
Obsoletes:	x11-driver-video-nv < 2.1.20-13
ExclusiveArch:	%{ix86} x86_64 aarch64

%description
The nouveau project aims to build high-quality, open source drivers
for NVIDIA cards.

%prep
%if 0%{snapshot}
%setup -q -n %{upname}-%{snapshot}
%else
%setup -q -n %{upname}-%{version}
%endif
%autopatch -p1
grep -q %{version} configure.ac

%build
%if 0%{snapshot}
autoreconf -v --install
%endif
# add -fpermissive (opensuse boo#1225956) to build with gcc14
export CFLAGS="%{optflags} -fpermissive"
%configure
%make_build

%install
%make_install

%files
%{_libdir}/xorg/modules/drivers/nouveau_drv.so
%{_mandir}/man4/nouveau*


%changelog
* Tue Oct 01 2024 ghibo <ghibo> 1.0.17-9.mga10
+ Revision: 2102267
- Try fixing gcc14 building with -fpermissive and dropping suggested Patch3 and -fno-plt.
- Merge patch from opensuse to get log more verbose on 3D acceleration disabled on some chipset.
- Cleanup unused BRs.

* Mon Sep 30 2024 daviddavid <daviddavid> 1.0.17-8.mga10
+ Revision: 2102051
- compile with '-fno-plt' build flags to fix an undefined symbol exaDriveralloc

* Sat Sep 28 2024 daviddavid <daviddavid> 1.0.17-7.mga10
+ Revision: 2101712
- backport upstream patch to fix build with GCC 14

* Sat Feb 11 2023 ghibo <ghibo> 1.0.17-6.mga9
+ Revision: 1940460
- Rebuild for aging.
- Add Url as referement to upstream fixes.
- Cleanup unused Source0 Url.

* Fri Apr 01 2022 umeabot <umeabot> 1.0.17-5.mga9
+ Revision: 1838275
- Mageia 9 Mass Rebuild

* Thu Mar 03 2022 tmb <tmb> 1.0.17-4.mga9
+ Revision: 1788177
- rebuild with gcc 12

* Sat Oct 02 2021 tmb <tmb> 1.0.17-2.mga9
+ Revision: 1748543
- fix filelist
- nouveau: fixup driver for new X server ABI
- remove sarea.h usage

* Sun Jan 24 2021 tmb <tmb> 1.0.17-1.mga8
+ Revision: 1673157
- update to 1.0.17

* Thu Jan 07 2021 luigiwalser <luigiwalser> 1.0.16-7.mga8
+ Revision: 1669635
- kmod(nouveau.ko) does not exist on armv7hl, do not build for that arch

* Tue Dec 15 2020 tmb <tmb> 1.0.16-6.mga8
+ Revision: 1657928
- drmmode: fix screen resize without acceleration
- present: don't enable if there's no acceleration
- drmmode: make event handler leave a note that there are stuck events
- present: fix handling of drmWaitVBlank failures

* Tue Nov 03 2020 akien <akien> 1.0.16-4.mga8
+ Revision: 1642137
- Rebuild for armv7hl

* Sat Apr 25 2020 tmb <tmb> 1.0.16-3.mga8
+ Revision: 1572153
- Don't advertise any PRIME offloading capabilities without acceleration
- nv4/exa: tiling is unsupported pre-nv10, reduce alignment requirements
- dri2,present: move in pixmap before getting addresses
- ake error when failing to allocate surface more descriptive

* Fri Feb 14 2020 umeabot <umeabot> 1.0.16-2.mga8
+ Revision: 1522604
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x
- replace deprecated %%makeinstall_std

* Tue Jan 29 2019 tv <tv> 1.0.16-1.mga7
+ Revision: 1361824
- new release

* Thu Dec 27 2018 tmb <tmb> 1.0.15-5.mga7
+ Revision: 1345290
- modesetting: Validate the atom for enum properties
- man: remove reference to glamor under DRI option
- dri3: remove bogus condition for creating pixmap
- nv50/xv: add support for depth 30 xv output
- dri3: don't check permissions on render node
- drmmode: provide better error when failing to set gamma
- fix colormap handling at screen depth 30. (v2)
- drmmode: update logic for dynamic connectors, paths, and tiles

* Sun Sep 23 2018 umeabot <umeabot> 1.0.15-4.mga7
+ Revision: 1301761
- Mageia 7 Mass Rebuild

* Fri Mar 09 2018 tv <tv> 1.0.15-3.mga7
+ Revision: 1207641
- rebuild for xserver 1.20 RC1

* Sat Sep 02 2017 tmb <tmb> 1.0.15-2.mga7
+ Revision: 1150689
- rebuild with new gcc/binutils

* Sun Apr 23 2017 tv <tv> 1.0.15-1.mga6
+ Revision: 1097120
- new release

* Thu Mar 09 2017 tv <tv> 1.0.14-1.mga6
+ Revision: 1090609
- new release

* Thu Nov 17 2016 tv <tv> 1.0.13-2.mga6
+ Revision: 1067625
- rebuild for xserver 1.19

* Fri Sep 23 2016 tv <tv> 1.0.13-1.mga6
+ Revision: 1055503
- remove merged patches
- new release

* Sat Jul 23 2016 tmb <tmb> 1.0.12-11.mga6
+ Revision: 1043258
- rebuild for xorg-server 1.18.4

* Tue Jul 05 2016 tmb <tmb> 1.0.12-10.mga6
+ Revision: 1038945
- sync in fixes from upstream git

* Sun Dec 27 2015 tv <tv> 1.0.12-9.mga6
+ Revision: 915920
- obsoletes x11-driver-video-nv

* Tue Dec 08 2015 tv <tv> 1.0.12-8.mga6
+ Revision: 908931
- new release

* Wed Nov 11 2015 tv <tv> 1.0.11-10.20151008.8.mga6
+ Revision: 902267
- submit to core/release

* Wed Nov 11 2015 tv <tv> 1.0.11-9.20151008.8.mga6
+ Revision: 901539
- git snapshot compatible with xserver 1.18
- rebuild for new xserver

* Fri Aug 21 2015 tmb <tmb> 1.0.11-7.mga6
+ Revision: 867090
- rebuild for new gcc

* Thu Aug 20 2015 tmb <tmb> 1.0.11-6.mga6
+ Revision: 866733
- rebuild with gcc 5.2.1

* Sat Jun 20 2015 tv <tv> 1.0.11-5.mga6
+ Revision: 835929
- rebuild for xserver 1.17

* Sat Feb 21 2015 tmb <tmb> 1.0.11-5.mga5
+ Revision: 816263
- sync with upstream

* Wed Oct 15 2014 umeabot <umeabot> 1.0.11-4.mga5
+ Revision: 747675
- Second Mageia 5 Mass Rebuild

* Wed Sep 24 2014 tmb <tmb> 1.0.11-3.mga5
+ Revision: 724101
- adapt to new kmod provides

* Tue Sep 16 2014 umeabot <umeabot> 1.0.11-2.mga5
+ Revision: 690441
- Mageia 5 Mass Rebuild

* Sat Sep 06 2014 tv <tv> 1.0.11-1.mga5
+ Revision: 672553
- new release

* Sat Jun 14 2014 tv <tv> 1.0.10-7.mga5
+ Revision: 636096
- add server managed fd support (from FC)

* Mon Jun 09 2014 tmb <tmb> 1.0.10-6.mga5
+ Revision: 635191
- rebuild for x11-server 1.16
+ tv <tv>
- submit to core/release

* Fri Jun 06 2014 tv <tv> 1.0.10-5.mga5
+ Revision: 633639
- rebuild for new xserver RC

* Tue Apr 15 2014 tv <tv> 1.0.10-5.mga5.nonfree
+ Revision: 614541
- rebuild for new xserver
- rebuild for new xserver

* Tue Feb 04 2014 tv <tv> 1.0.10-4.mga5
+ Revision: 582238
- rebuild for new xserver

* Fri Dec 06 2013 tmb <tmb> 1.0.10-3.mga4
+ Revision: 555563
- rebuild for new mesa

* Wed Dec 04 2013 tmb <tmb> 1.0.10-2.mga4
+ Revision: 555160
- try build with mesa 10

* Fri Nov 08 2013 tv <tv> 1.0.10-1.mga4
+ Revision: 549910
- new release

* Sat Oct 19 2013 umeabot <umeabot> 1.0.9-5.mga4
+ Revision: 531818
- Mageia 4 Mass Rebuild

* Sun Aug 11 2013 tmb <tmb> 1.0.9-4.mga4
+ Revision: 465414
- rebuild with new gcc

* Thu Aug 01 2013 tmb <tmb> 1.0.9-3.mga4
+ Revision: 462262
- force gcc 4.8.2 build

* Thu Aug 01 2013 tmb <tmb> 1.0.9-2.mga4
+ Revision: 462190
- test gcc-4.8.2 build

* Tue Jul 30 2013 tmb <tmb> 1.0.9-1.mga4
+ Revision: 460958
- update to 1.0.9

* Wed Jun 12 2013 tv <tv> 1.0.8-1.mga4
+ Revision: 442092
- new release

* Thu May 30 2013 tv <tv> 1.0.7-3.mga4
+ Revision: 433115
- submit to core/release

* Fri May 24 2013 tv <tv> 1.0.7-2.mga4
+ Revision: 425654
- rebuild with xserver-1.14

* Thu May 23 2013 tv <tv> 1.0.7-1.mga4
+ Revision: 424868
- new release

* Mon Jan 14 2013 umeabot <umeabot> 1.0.6-2.mga3
+ Revision: 385998
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Jan 07 2013 tv <tv> 1.0.6-1.mga3
+ Revision: 340935
- new release
- new URL

* Fri Nov 09 2012 tv <tv> 1.0.4-1.mga3
+ Revision: 316709
- new release

* Wed Oct 24 2012 tv <tv> 1.0.3-1.mga3
+ Revision: 309623
- new release

* Thu Sep 13 2012 tv <tv> 1.0.2-1.mga3
+ Revision: 293444
- new release

* Mon Sep 10 2012 blino <blino> 1.0.1-5.20120910.1.mga3
+ Revision: 292078
- fix snapshot builds
- update to git snapshot of 20120910 for PRIME support (DRI2 offload + provider)

* Thu Sep 06 2012 tv <tv> 1.0.1-4.mga3.nonfree
+ Revision: 288995
- rebuild for new xserver
- rebuild for new xserver

* Thu Jul 19 2012 tmb <tmb> 1.0.1-3.mga3
+ Revision: 272400
- rebuild for new glibc
+ colin <colin>
- Temporarily downgrade nouveau drm requirements
- Rebuild against new (old) libdrm_nouveau

* Fri Jun 29 2012 colin <colin> 1.0.1-2.mga3
+ Revision: 264947
- Rebuild against new libudev major

* Tue Jun 19 2012 fwang <fwang> 1.0.1-1.mga3
+ Revision: 261916
- new version 1.0.1
- use offical tarball

* Mon Jun 18 2012 tv <tv> 1.0.0-1.mga3
+ Revision: 261812
- fix non snapshot build
- new release (1.0.0!!!)

* Wed Jun 06 2012 tmb <tmb> 0.0.16-1.20120530.3.mga3
+ Revision: 256444
- rebuild for core/release

* Fri Jun 01 2012 tv <tv> 0.0.16-1.20120530.2.mga3
+ Revision: 252967
- rebuild b/c of ia32 failure

* Wed May 30 2012 tv <tv> 0.0.16-0.20120530.1.mga3.nonfree
+ Revision: 250200
- new snapshot
- rebuild for new X.org server

* Sun Mar 25 2012 tmb <tmb> 0.0.16-0.20120322.1.mga2
+ Revision: 226208
- update to 2012-03-22, adds Kepler (GTX6xx) support

* Tue Dec 06 2011 tmb <tmb> 0.0.16-0.20111203.2.mga2
+ Revision: 177462
- submit to core/release

* Sat Dec 03 2011 anssi <anssi> 0.0.16-0.20111203.1.mga2
+ Revision: 175273
- new snapshot

* Sat Oct 08 2011 tv <tv> 0.0.16-0.20110303.5.mga2
+ Revision: 153303
- really rebuild for xserver-1.11

* Sat Oct 08 2011 tv <tv> 0.0.16-0.20110303.4.mga2
+ Revision: 153088
- rebuild for xserver-1.11

* Sat Mar 05 2011 tmb <tmb> 0.0.16-0.20110303.3.mga1
+ Revision: 65083
- update to 2011-03-03 snapshot

* Fri Mar 04 2011 tv <tv> 0.0.16-0.20110107.2.mga1
+ Revision: 64446
- rebuild for new xserver-1.10

* Fri Feb 11 2011 tmb <tmb> 0.0.16-0.20110107.1.mga1
+ Revision: 50637
- update to 2011-01-07 snapshot
- add P0: revert changes not supported by 2.6.37 series headers
+ blino <blino>
- imported package x11-driver-video-nouveau


* Sun Nov 07 2010 Thierry Vignaud <tv@mandriva.org> 0.0.16-0.20100816.3mdv2011.0
+ Revision: 594705
- require x11-server-common in order to cheat poor env on kenobi which is 2010.x

* Sun Oct 10 2010 Thierry Vignaud <tv@mandriva.org> 0.0.16-0.20100816.2mdv2011.0
+ Revision: 584626
- bump release before rebuilding for xserver 1.9

* Mon Aug 16 2010 Anssi Hannula <anssi@mandriva.org> 0.0.16-0.20100816.1mdv2011.0
+ Revision: 570270
- new snapshot

* Sat Jul 24 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 0.0.16-0.20100724.1mdv2011.0
+ Revision: 558115
- update to new snapshot 20100724
- bump version to 0.0.16
- add buildrequires on udev-devel

* Wed Mar 17 2010 Anssi Hannula <anssi@mandriva.org> 0.0.15-0.20100316.1mdv2010.1
+ Revision: 523326
- new snapshot
  o ABI change, this version will require a new kernel
    (e.g. main kernel 2.6.33.1-1mnb)
- bump libdrm requirement
- obsoletes nouveau-firmware, no longer used
- ensure version correctness in prep

* Sat Feb 06 2010 Anssi Hannula <anssi@mandriva.org> 0.0.15-0.20100206.1mdv2010.1
+ Revision: 501484
- bump buildrequires on libdrm-devel
- new snapshot
- drop unneeded configure options
- drop unneeded patches (dcbconf_7_4_ignore.patch, bgnr.patch,
  multiple-xserver.patch)

* Mon Dec 21 2009 Anssi Hannula <anssi@mandriva.org> 0.0.15-0.20091221.1mdv2010.1
+ Revision: 480929
- new snapshot
- update summary and description
- drop unapplied bicupic-2x.patch
- drop store-vbios.patch, we do not need to store bios
- remove BR on kernel-headers which is already required by glibc-devel

* Fri Dec 18 2009 Thomas Backlund <tmb@mandriva.org> 0.0.15-0.20091204.2mdv2010.1
+ Revision: 480016
- require nouveau-firmware (needed for 2.6.33 series kernels)

* Fri Dec 04 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.0.15-0.20091204.1mdv2010.1
+ Revision: 473511
- update to new snapshot 20091204
- bump version requires on libdrm to 2.4.16
- disable patch 3

* Sat Nov 14 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.0.15-0.20091111.1mdv2010.1
+ Revision: 466090
- revert to older commit, which does not need git version of libdrm
- update to new snapshot 20091108
- update to new snapshot 20091024
- provide better description

* Sat Sep 26 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.0.15-0.20090926.1mdv2010.0
+ Revision: 449543
- new snapshot 20090926
- Patch3: xv only use bicubic filtering when scaling >=2x
- Patch4: support multiple xserver instances

* Mon Sep 21 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.0.10-0.20090921.2mdv2010.0
+ Revision: 446868
- new snapshot 20090921

* Sun Sep 13 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.0.10-0.20090913.2mdv2010.0
+ Revision: 439019
- new snapshot 20090913

* Mon Sep 07 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.0.10-0.20090907.2mdv2010.0
+ Revision: 432857
- update to new snapshot 20090907
- add three patches from Fedora

* Sun Aug 09 2009 Anssi Hannula <anssi@mandriva.org> 0.0.10-0.20090809.1mdv2010.0
+ Revision: 412950
- new snapshot

* Sun Aug 02 2009 Anssi Hannula <anssi@mandriva.org> 0.0.10-0.20090803.1mdv2010.0
+ Revision: 407656
- new snapshot
- bump buildrequires on libdrm-devel

* Fri Jul 24 2009 Anssi Hannula <anssi@mandriva.org> 0-0.20090724.1mdv2010.0
+ Revision: 399516
- new snapshot
- bump buildrequires on libdrm-devel
- obsolete dkms-nouveau for now

* Sat May 30 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0-0.20090530.1mdv2010.0
+ Revision: 381352
- new snapshot

* Mon Mar 02 2009 Anssi Hannula <anssi@mandriva.org> 0-0.20090302.1mdv2009.1
+ Revision: 347411
- new snapshot
- drop format-string.patch, fixed upstream

* Sun Jan 11 2009 Anssi Hannula <anssi@mandriva.org> 0-0.20090111.1mdv2009.1
+ Revision: 328160
- new snapshot
- drop lcd bit patch, fixed upstream
- P0: fix format string

* Fri Sep 12 2008 Anssi Hannula <anssi@mandriva.org> 0-0.20080912.1mdv2009.0
+ Revision: 284259
- new snapshot

* Thu Jun 05 2008 Anssi Hannula <anssi@mandriva.org> 0-0.20080605.1mdv2009.0
+ Revision: 215170
- new snapshot
- do not force failure on those unknown LVDS bits that have been reported
  already

  + Thierry Vignaud <tv@mandriva.org>
    - improved description
    - add missing dot at end of description

* Fri May 09 2008 Anssi Hannula <anssi@mandriva.org> 0-0.20080509.1mdv2009.0
+ Revision: 204767
- new snapshot

* Thu May 01 2008 Anssi Hannula <anssi@mandriva.org> 0-0.20080501.1mdv2009.0
+ Revision: 199905
- new snapshot

* Tue Apr 15 2008 Anssi Hannula <anssi@mandriva.org> 0-0.20080415.1mdv2009.0
+ Revision: 193605
- new snapshot

* Sat Feb 23 2008 Anssi Hannula <anssi@mandriva.org> 0-0.20080223.1mdv2008.1
+ Revision: 174091
- new snapshot

* Tue Feb 05 2008 Anssi Hannula <anssi@mandriva.org> 0-0.20080205.1mdv2008.1
+ Revision: 162738
- new snapshot

* Sun Jan 20 2008 Anssi Hannula <anssi@mandriva.org> 0-0.20080120.1mdv2008.1
+ Revision: 155158
- new snapshot

* Fri Jan 11 2008 Anssi Hannula <anssi@mandriva.org> 0-0.20080111.1mdv2008.1
+ Revision: 148729
- new snapshot

* Wed Jan 02 2008 Anssi Hannula <anssi@mandriva.org> 0-0.20080102.1mdv2008.1
+ Revision: 140292
- new snapshot

* Tue Dec 25 2007 Anssi Hannula <anssi@mandriva.org> 0-0.20071224.1mdv2008.1
+ Revision: 137627
- initial Mandriva release

